
//TangleCube
int n; 
int[] N= new int[12];
int anzahlPunkte =0;
int prozent =0;
int scale = 150;
int farbFaktor = 150;
float farbe1,farbe2;
float winkelA, winkelB;
float farbeHSB = 0;
float farbeVerlauf =0;
float step;//Abtast-Abstand
float ff =1; //Fehlerfaktor

float p; //maximaler Fehler ohne ff
float P; //maximaler angepasster Fehler
float delta;//Wichtig! Schrittweite beim Abtasten
boolean farbeWechseln = true;    
boolean zeichnen =false;
boolean farbverlaufGewaehlt = true;
boolean lichtV,lichtH,lichtR,lichtL,lichtO,lichtU;
color farbeVon;
color farbeBis;
color farbe;
float R=0;//Entfernung des Punktes vom Ursprung
float r;//Kamera-Abstand zum Ursprung
float Radius =0;
PVector camOrt;
boolean nextStep = true;
ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
ArrayList<Punkt> punkte = new ArrayList<Punkt>();
ArrayList<Punkt> temp   = new ArrayList<Punkt>();


void setup(){
   size(800, 800, P3D);
   background(0);
   smooth(8);
   colorMode(HSB);
   //Zunächst Licht von vorn:
   lichtH=false; lichtV=true; lichtO=true; lichtU=true; lichtR=true; lichtL=true;
   winkelA =  -0.196;//0.39;//PI/2;
   winkelB =  -0.576;//-0.576;// 3*PI/2;
   p= 0.008; 
   P = ff*p; 
   r=600;
   step = 0.5;   
   delta = step/scale;
   
   starten();
   
}

void draw(){
  if(nextStep){  
   
   background(0);
   if(farbeWechseln){
     farbe1=random(255);
     while(abs(farbe1-farbe2) < 120){
        farbe2 = random(255);
     }
     farbeVon = color(farbe1,random(220,255),random(220,255));
     farbeBis = color(farbe2,random(220,255),random(220,255));
     println("Farbverlauf von "+hue(farbeVon)+" bis "+hue(farbeBis));
     farbeWechseln=false;
   }
   noStroke();
   camOrt = kameraOrtBerechnen(winkelA,winkelB,r);
   println("Winkel A: "+winkelA*360/2/PI,"Winkel B: "+winkelB*360/2/PI);
   camera(camOrt.x,camOrt.y,camOrt.z,0,0,0,0,1,0);
   if(zeichnen) boxesZeichnen();
   nextStep=false;
   System.gc();
  }
   
}
void starten(){
   punkte.clear();temp.clear();
 
   
   multiThreadsStarten();
   anzahlPunkte = punkte.size();
   println("Anzahl Punkte in punkte: "+anzahlPunkte);
   zeichnen =true;
}
void multiThreadsStarten(){
   workers.clear();
   for (int i=0; i<12; i++)
    {
      workers.add(new WorkThread(i)); 
    }
    for (WorkThread worker : workers) {  
      while (worker.running)
      {       
        try{
        Thread.sleep(10);  
        }catch (Exception e) {  }  ;                
      }
    }
    temp = workers.get(0).punkte00;    
    println("Übertragene Anzahl  0: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);//println(" Übergabe: "+punkt.x,punkt.y,punkt.z,punkt.r);
    }
    temp = workers.get(1).punkte01;    
    println("Übertragene Anzahl  1: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(2).punkte02;    
    println("Übertragene Anzahl  2: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(3).punkte03;    
    println("Übertragene Anzahl  3: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(4).punkte04;    
    println("Übertragene Anzahl  4: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(5).punkte05;    
    println("Übertragene Anzahl  5: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(6).punkte06;    
    println("Übertragene Anzahl  6: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(7).punkte07;    
    println("Übertragene Anzahl  7: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(8).punkte08;    
    println("Übertragene Anzahl  8: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(9).punkte09;    
    println("Übertragene Anzahl  9: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(10).punkte10;    
    println("Übertragene Anzahl 10: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
    temp = workers.get(11).punkte11;    
    println("Übertragene Anzahl 11: "+temp.size());
    for(Punkt punkt: temp){
        punkte.add(punkt);
    }
}

void boxesZeichnen(){
  int zaehler =0;
  if(lichtV) {directionalLight(0, 0, 255, 0, 0, -1); println("Licht von vorn");}
  if(lichtH) {directionalLight(0, 0, 255, 0, 0,  1); println("Licht von hinten");}
  if(lichtR) {directionalLight(0, 0, 255,-1, 0,  0); println("Licht von rechts");}
  if(lichtL) {directionalLight(0, 0, 255, 1, 0,  0); println("Licht von links");}
  if(lichtO) {directionalLight(0, 0, 255, 0,-1,  0); println("Licht von oben");}
  if(lichtU) {directionalLight(0, 0, 255, 0, 1,  0); println("Licht von unten");}
  for (Punkt punkt: punkte){
    
    Radius = sqrt(sq(punkt.x)+ sq(punkt.y)+ sq(punkt.z));
    farbeHSB =farbFaktor*Radius % 256;
    
    if(farbeHSB<128) {
      farbeVerlauf =  map((float)farbeHSB,0,128,0,1);
      farbe = lerpColor(farbeVon,farbeBis,farbeVerlauf);
    }else{
      farbeVerlauf =  map((float)farbeHSB,128,256,0,1);
      farbe = lerpColor(farbeBis,farbeVon,farbeVerlauf);
    }
    if(!farbverlaufGewaehlt) fill(farbeHSB,255,255);
    else fill(farbe);  
    //Ausnutzung der Symmetrie in x,y und z:
   pushMatrix();  
      translate(scale*punkt.x, scale*punkt.y,scale*punkt.z); 
      box(step);    
    popMatrix();
    pushMatrix();  
       translate(-scale*punkt.x, scale*punkt.y,scale*punkt.z); 
      box(step);    
    popMatrix();
    pushMatrix();  
       translate(scale*punkt.x, -scale*punkt.y,scale*punkt.z); 
      box(step);    
    popMatrix();
     pushMatrix();  
       translate(scale*punkt.x, scale*punkt.y,-scale*punkt.z); 
      box(step);    
    popMatrix();
    pushMatrix();  
      translate(-scale*punkt.x, -scale*punkt.y,scale*punkt.z); 
      box(step);    
    popMatrix();
     pushMatrix();  
      translate(-scale*punkt.x, scale*punkt.y,-scale*punkt.z); 
      box(step);    
    popMatrix();
    pushMatrix();  
      translate(scale*punkt.x, -scale*punkt.y,-scale*punkt.z); 
      box(step);    
    popMatrix();
    pushMatrix();  
      translate(-scale*punkt.x, -scale*punkt.y,-scale*punkt.z); 
      box(step);    
    popMatrix();
    zaehler++;
    if(zaehler % 100000==0){
      prozent = int((float)zaehler/(float)anzahlPunkte*100);
      println(prozent+"% gezeichnet");
    }
  }
  println("Fertig gezeichnet!");
  zeichnen = false;
}
void keyPressed(){
  if(key == 'f'){
    farbverlaufGewaehlt = !farbverlaufGewaehlt;
    farbeVon = color(random(255),random(220,255),random(220,255));
    farbeBis = color(random(255),random(220,255),random(220,255));
   // background(0);
    nextStep = true;
    if(farbverlaufGewaehlt) println("Färbung durch zufälligen Farbverlauf");
    else println("Standard Färbung");
    starten();
  }
  if(key == 'F'){
    farbeWechseln = true; println("Farbe gewechselt");
    nextStep=true;  
    starten();
  }
  if(key == CODED){
    if(keyCode == RIGHT){
      winkelA = winkelA+PI/16; 
      nextStep=true;  
      starten();
    }
    if(keyCode == LEFT) {
      winkelA = winkelA-PI/16; 
      nextStep=true;
      starten();
   }
    if(keyCode == UP)   {
     if(winkelB < PI/2-PI/15) winkelB = winkelB+PI/16;    
      nextStep=true;
      starten();
    }
    if(keyCode == DOWN) {
      if(winkelB > -PI/2+PI/15)winkelB = winkelB-PI/16; 
      nextStep=true;
      starten();
    }
  } 
    if(key=='o') {lichtO=!lichtO;nextStep = true;starten();}
    if(key=='u') {lichtU=!lichtU;nextStep = true;starten();}
    if(key=='l') {lichtL=!lichtL;nextStep = true;starten();}
    if(key=='r') {lichtR=!lichtR;nextStep = true;starten();}
    if(key=='v') {lichtV=!lichtV;nextStep = true;starten();}
    if(key=='h') {lichtH=!lichtH;nextStep = true;starten();}
    if(key=='p'&& r>90) {r= r-50;nextStep = true;starten();}
    if(key=='P') {r=r+50;nextStep = true;starten();}
    if(key=='m') {step=step/2;nextStep = true;starten();println("Step: "+step);}
    if(key=='M') {step=2*step;nextStep = true;starten();println("Step: "+step);}
    if(key=='z') {ff=0.8*ff;P=ff*p;nextStep = true;starten();println(" effektiver Fehler: "+P);}
    if(key=='Z') {ff=1.2*ff;nextStep = true;starten();println("Fehlerfaktor: "+ff);}
    if(key=='s') save("Bild.png");
  // background(0);
}
float radius(float x, float y, float z){
  R =sqrt(sq(x)+sq(y)+sq(z));
  return R;
}
PVector kameraOrtBerechnen(float a, float b, float r){
  PVector Ort = new PVector();
  float radius;
  float wA,wB;
  wA = a; wB = b; radius =r;
 
  Ort.x = radius*cos(wA)*cos(wB);
  Ort.y = radius*cos(wA)*sin(wB);
  Ort.z= radius*sin(wA);
  return Ort;
  
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////
class WorkThread implements Runnable {

 
  protected boolean running = true;
  private float xMin =    0 ;
  private float xMax =    1.3;
  private float yMin =    0;
  private float yMax =    1.3;
  private float zMin =    0;
  private float zMax =    1.3;
  private float[] x = new float[12];
  private float[] y = new float[12];
  private float[] z = new float[12];
  private float[] D = new float[12];//Abweichung von Null
  private float[] R = new float[12];//Abstand des Punktes von 0
  private int nummer;
  private float abstandsFaktor =1;//Anpassung an Aufnahmekriterium eines Punktes zur dargestellten Fläche
  
  ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
 
  ArrayList<Punkt> punkte00 = new ArrayList<Punkt>(); 
  ArrayList<Punkt> punkte01 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte02 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte03 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte04 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte05 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte06 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte07 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte08 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte09 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte10 = new ArrayList<Punkt>();
  ArrayList<Punkt> punkte11 = new ArrayList<Punkt>();

  public WorkThread (int nummer){
    //wegen get(n-1) in switch
   
   /* punkte00.add(new Punkt(0,0,0,0));  
    punkte01.add(new Punkt(0,0,0,0));  
    punkte02.add(new Punkt(0,0,0,0));  
    punkte03.add(new Punkt(0,0,0,0));  
    punkte04.add(new Punkt(0,0,0,0));  
    punkte05.add(new Punkt(0,0,0,0));  
    punkte06.add(new Punkt(0,0,0,0));  
    punkte07.add(new Punkt(0,0,0,0));  
    punkte08.add(new Punkt(0,0,0,0));  
    punkte09.add(new Punkt(0,0,0,0));  
    punkte10.add(new Punkt(0,0,0,0));  
    punkte11.add(new Punkt(0,0,0,0));  */
    this.nummer = nummer;
    Thread thread = new Thread(this);
    thread.start();
  }
  
  public void run() {  
    println(" Delta: "+delta," Fehler: "+P);
    this.running = true;
    println("Die interne Threadnummer ist: " 
     + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
    
   
    switch(nummer){  
      case 0:punkteBerechnen( 0); break;              
      case 1:punkteBerechnen( 1); break;                
      case 2:punkteBerechnen( 2); break;                 
      case 3:punkteBerechnen( 3); break;            
      case 4:punkteBerechnen( 4); break;            
      case 5:punkteBerechnen( 5); break;          
      case 6:punkteBerechnen( 6); break;       
      case 7:punkteBerechnen( 7); break;            
      case 8:punkteBerechnen( 8); break;       
      case 9:punkteBerechnen( 9); break;          
      case 10:punkteBerechnen(10); break;            
      case 11:punkteBerechnen(11); break;       
    }
    println("Threads mit Nummer "+nummer+" ist fertig!");   
    this.running = false;
  }
  
   void punkteBerechnen(int n){
     x[n] = xMin+n*(xMax-xMin)/12; y[n] = yMin;z[n] = zMin;
       while(x[n]<=xMin+(n+1)*(xMax-xMin)/12) {  
         while (y[n]<=yMax) {
           while(z[n]<=zMax){
             D[n]= implFunktion(x[n],y[n],z[n]);
             R[n]= abstandVomUrsprung(x[n],y[n],z[n]);                
             if(R[n] <=1) abstandsFaktor =1;
             else abstandsFaktor = sq(R[n])*sq(R[n]);
             if(D[n] < abstandsFaktor*P){//Symmetrie!
               punktHinzu(n,new Punkt(x[n],y[n],z[n],D[n]));                
             }
             z[n]=z[n]+delta;
          }
         z[n]=zMin;
         y[n]=y[n]+delta;
       }
       y[n]=yMin;
       x[n]=x[n]+delta;   if(n==0)println(x[0]=x[0]);     
      }     
  }
  
   void punktHinzu(int n, Punkt p){    
    switch(n){
      case  0: punkte00.add(p); break;
      case  1: punkte01.add(p); break;
      case  2: punkte02.add(p); break;
      case  3: punkte03.add(p); break;
      case  4: punkte04.add(p); break;
      case  5: punkte05.add(p); break;
      case  6: punkte06.add(p); break;
      case  7: punkte07.add(p); break;
      case  8: punkte08.add(p); break;
      case  9: punkte09.add(p); break;
      case 10: punkte10.add(p); break;
      case 11: punkte11.add(p); break;
    }   
  }
  //Tanglecube
  float implFunktion(float x,float y, float z){
    float d;
    d =  abs(sq((2.92*(x-1)*sq(x)*(x+1)+1.7*sq(y)))*sq((sq(y)-0.88)) 
           + sq((2.92*(y-1)*sq(y)*(y+1)+1.7*sq(z)))*sq((sq(z)-0.88)) 
           + sq((2.92*(z-1)*sq(z)*(z+1)+1.7*sq(x)))*sq((sq(x)-0.88))-0.02 );
    return d;
  }
  
  float abstandVomUrsprung( float x,float y, float z){
     float r;
     r = sqrt(sq(x)+sq(y)+sq(z));
     return r;
  }
}

////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
class Punkt {
  float x,y,z,r;
  
  Punkt(float X, float Y, float Z, float R){
    x=X; y=Y;z=Z;r=R;
  }
}
